DECLARE SUB Lines ()
DECLARE SUB Nodes ()
DECLARE SUB PolygonDraw (G AS INTEGER)
DECLARE SUB PalSet ()
DECLARE SUB Rotate (Delay AS LONG, R AS INTEGER)

DECLARE FUNCTION ConvertMix$ (Mix$)
DECLARE FUNCTION RainBowMix$ (Mix$)
DECLARE FUNCTION MonoMix$ ()

DEFINT A-Z

DIM SHARED PSize AS INTEGER                      'Polygon size, PSize=6=Hexagon
DIM SHARED C(1 TO 12) AS INTEGER                 'Attribute array, LINE -(10,10),C(X)
DIM SHARED PMix(1 TO 12) AS LONG                 'Color array, PALETTE C(X),PMix(X)
DIM SHARED Colors(15) AS LONG                    'Color number array

'====================================================================
' Polygon menu
'====================================================================
DO
  CLS : SCREEN 0: WIDTH 80: KEY OFF: COLOR 10, 0
  LOCATE 3, 1
  PRINT "  Select Polygon"
  PRINT
  PRINT "     1. Lines"
  PRINT "     2. Nodes"
  PRINT "     3. Triangle"
  PRINT "     4. Quadrilateral"
  PRINT "     5. Pentagon"
  PRINT "     6. Hexagon"
  PRINT "     7. Heptagon"
  PRINT "     8. Octagon"
  PRINT "     9. Nonagon"
  PRINT "    10. Decagon"
  PRINT "    11. Undecagon"
  PRINT "    12. Dodecagon"
  PRINT "    13. Exit"
  PRINT
  INPUT " Item Number"; G
  PRINT
  SELECT CASE G
    CASE 1: Lines
    CASE 2: Nodes
    CASE 3: RESTORE 1003
    CASE 4: RESTORE 1004
    CASE 5: RESTORE 1005
    CASE 6: RESTORE 1006
    CASE 7: RESTORE 1007
    CASE 8: RESTORE 1008
    CASE 9: RESTORE 1009
    CASE 10: RESTORE 1010
    CASE 11: RESTORE 1011
    CASE 12: RESTORE 1012
    CASE 13: END
    CASE ELSE: G = 0
  END SELECT
  IF G > 2 AND G < 13 THEN PolygonDraw (G)
LOOP
'===================================================================
' Default RGB values, dark blue to white
'===================================================================
DefaultRGB:
DATA 00,00,42,00,42,00,00,42,42,42,00,00,42,00,42
DATA 42,21,00,42,42,42,21,21,21,21,21,63,21,63,21
DATA 21,63,63,63,21,21,63,21,63,63,63,21,63,63,63
'===================================================================
' Polygon definitions
'===================================================================
1003 DATA Triangle  ,000,000,320,479,639,000
1004 DATA Quadrangle,000,000,000,479,639,479,639,000
1005 DATA Pentagon  ,320,479,570,298,478,000,165,000,070,298
1006 DATA Hexagon   ,320,000,528,120,528,360,320,475,113,360,113,120
1007 DATA Heptagon  ,320,468,508,378,555,175,428,013,215,013,085,175,133,378
1008 DATA Octagon   ,320,000,490,070,560,240,490,410,320,475,150,410,080,240,150,070
1009 DATA Nonagon   ,320,473,475,418,558,275,528,113,405,008,238,008,113,113,083,275,163,418
1010 DATA Decagon   ,320,475,463,435,548,315,548,165,460,045,320,000,178,045,093,165,093,315,180,435
1011 DATA Undecagon ,320,475,450,438,538,335,558,200,503,078,390,005,253,005,138,078,083,200,103,335,188,438
1012 DATA Dodecagon ,320,475,443,450,528,363,560,243,528,123,440,035,320,003,198,035,113,123,080,243,113,363,200,450

'====================================================================
' Convert Mix$ characters to color values
'====================================================================
FUNCTION ConvertMix$ (Mix$)

SCREEN 12: COLOR 0
FOR N = 1 TO PSize                               'Convert Mix$ to color values
  A$ = MID$(Mix$, N, 1)                          'then load PMix with the values.
  IF A$ < "A" THEN
    A = VAL(A$)
  ELSE
    A = ASC(A$) - 55
    IF A > 15 THEN A = 15
  END IF
  C(N) = N                                       'Set attribute
  PMix(N) = Colors(A)                            'Set color number
  PALETTE N, Colors(A)                           'Set attribute to color number
NEXT N

END FUNCTION

'====================================================================
' Moving lines
'====================================================================
SUB Lines

DIM A AS LONG, A1 AS LONG, B AS LONG, B1 AS LONG, Count AS LONG
DIM X AS LONG, X1 AS LONG, Y AS LONG, Y1 AS LONG, Delay AS LONG

CLS : COLOR 12: PRINT : PRINT " Computer Art": PRINT : COLOR 10
PRINT " This routine draws a constantly moving & twisting line.  You choose the number"
PRINT " of lines to draw.  The display is restarted after each line count is finished."
PRINT
PRINT " Pressing any key during display returns to the main menu.": PRINT
INPUT " Line Count"; Count
IF Count = 0 THEN Count = 1000: LOCATE CSRLIN - 1, 13: PRINT Count
PRINT
INPUT " Drawing Speed"; Delay
IF Delay = 0 THEN Delay = 1000: LOCATE CSRLIN - 1, 16: PRINT Delay
PRINT
INPUT " Seconds to pause between screens"; P
IF P = 0 THEN P = 5: LOCATE CSRLIN - 1, 35: PRINT P
PRINT

INPUT " Mono or Rainbow mix (M/R)"; Mix$
Mix$ = UCASE$(Mix$)
IF Mix$ = "R" THEN
  PRINT : INPUT " Bandwidth"; W
  IF W = 0 THEN W = Count / 50: LOCATE CSRLIN - 1, 12: PRINT W
END IF
RANDOMIZE TIMER
A = RND * 639: B = RND * 479: X = RND * 639: Y = RND * 479: A1 = 2: B1 = 2: X1 = 4: Y1 = 4
SCREEN 12: COLOR 0
DO
  R = RND * 15 + 1
  L = 1
  FOR N = 1 TO Count
    IF A <= 0 OR A >= 639 THEN A1 = -A1
    IF A <= 0 OR A >= 639 THEN A = A + A1
    IF X <= 0 OR X >= 639 THEN X1 = -X1
    IF X <= 0 OR X >= 639 THEN X = X + X1
    IF B <= 0 OR B >= 479 THEN B1 = -B1
    IF B <= 0 OR B >= 479 THEN B = B + B1
    IF Y <= 0 OR Y >= 479 THEN Y1 = -Y1
    IF Y <= 0 OR Y >= 479 THEN Y = Y + Y1
    L = L + 1
    IF L = W AND Mix$ = "R" THEN R = RND * 15 + 1: L = 1
    LINE (A, B)-(X - A, Y - B), R
    A = A + A1: B = B + B1: X = X + X1: Y = Y + Y1
    FOR I = 1 TO Delay: NEXT
    IF INKEY$ <> "" THEN EXIT SUB
  NEXT
  IF P > 0 THEN SLEEP P
  CLS
LOOP

END SUB

'====================================================================
' Fill Mix$ with random mono color
'====================================================================
FUNCTION MonoMix$

DIM Mono AS INTEGER

RANDOMIZE TIMER
Mono = RND * 6 + 1
FOR N = 1 TO PSize
  Mix$ = Mix$ + RIGHT$(STR$(Mono), 1)
NEXT
DIM R(15) AS INTEGER, G(15) AS INTEGER, B(15) AS INTEGER, CM AS INTEGER
CM = 1
FOR N = 0 TO 63 STEP 8                           'Set palette fading values, first the dark colors, 1 to 8
  SELECT CASE Mono
    CASE 1                                       'Blue
      B(CM) = N
    CASE 2                                       'Green
      G(CM) = N
    CASE 3                                       'Cyan
      G(CM) = N: B(C) = N
    CASE 4                                       'Red
      R(CM) = N
    CASE 5                                       'Purple
      R(CM) = N: B(C) = N
    CASE 6                                       'Orange
      R(CM) = N: G(C) = N / 2
    CASE 7                                       'Grey
      R(CM) = N: G(C) = N: B(C) = N
  END SELECT
  CM = CM + 1
NEXT
CM = CM - 1
FOR N = 0 TO 63 STEP 8                           'Then the bright colors, 9 to 15
  SELECT CASE Mono
    CASE 1                                       'Blue
      R(CM) = N: G(CM) = N: B(CM) = 63
    CASE 2                                       'Green
      R(CM) = N: G(CM) = 63: B(CM) = N
    CASE 3                                       'Cyan
      R(CM) = N: G(CM) = 63: B(CM) = 63
    CASE 4                                       'Red
      R(CM) = 63: G(CM) = N: B(CM) = N
    CASE 5                                       'Purple
      R(CM) = 63: G(CM) = N: B(CM) = 63
    CASE 6                                       'Orange
      R(CM) = 63: G(CM) = N / 2 + 31: B(CM) = G(CM) / 2
    CASE 7                                       'Grey
      R(CM) = N / 2 + 31: G(CM) = N / 2 + 31: B(CM) = N / 2 + 31
  END SELECT
  CM = CM + 1
NEXT N

FOR N = 1 TO 15
  LET Colors(N) = (65536 * B(N)) + (256 * G(N)) + R(N)
NEXT N

MonoMix$ = LEFT$("56789ABCDEF4321", PSize)       'Fading colors starting at mid-dark

END FUNCTION

'====================================================================
' Draw nodes
'====================================================================
SUB Nodes

CONST PI = 3.14159
DIM Node AS SINGLE, Nodez AS INTEGER
DIM X(60) AS LONG, Y(60) AS LONG

CLS : COLOR 12: PRINT : PRINT " Nodes": PRINT : COLOR 10
PRINT " This routine draws a regular polygon with all the diagonals.  You choose the"
PRINT " number of nodes. Roald A. Schrack": PRINT
INPUT " Number of Nodes"; Nodez: PRINT
INPUT " Mono or Rainbow mix (M/R)"; Mix$
FOR I = 1 TO Nodez                               'Fill node arrays with X,Y screen coords
  Node = 2 * PI * I / Nodez
  X(I) = 60 * (4 * SIN(Node) + 15)
  Y(I) = 60 * (4 * COS(Node) + 8)
NEXT
SCREEN 12: COLOR 0
RANDOMIZE TIMER
C = RND * 15 + 1
FOR N = 1 TO Nodez - 1                           'Draw polygon
  IP = N + 1
  FOR M = IP TO Nodez
    X1 = X(N) - 580
    Y1 = 480 - (Y(N) - 240)
    X2 = X(M) - 580
    Y2 = 480 - (Y(M) - 240)
    LINE (X1, Y1)-(X2, Y2), C
  NEXT
  IF UCASE$(Mix$) = "R" THEN C = RND * 15 + 1
NEXT
SLEEP
END SUB

'====================================================================
' Palette setup
'====================================================================
SUB PalSet STATIC

RESTORE DefaultRGB                               'Standard RGB color values

FOR N = 1 TO 15                                  'Fill color number array
  READ R: READ G: READ B
  Colors(N) = (65536 * B) + (256 * G) + R
NEXT N

PRINT
PRINT "         =================================================================="
PRINT "   Dark    0-Black 1-Blue 2-Green  3-Cyan 4-Red 5-Purple 6-Orange 7-Grey"
PRINT "  Light    8-Gray  9-Blue A-Green  B-Cyan C-Red D-Purple E-Yellow F-White"
PRINT "         =================================================================="
PRINT
PRINT "  Enter"; : COLOR 12: PRINT PSize; : COLOR 10: PRINT "character color mix or"
PRINT "        " + CHR$(34) + "R" + CHR$(34) + " for random " + CHR$(34) + "Rainbow" + CHR$(34) + " mix or"
PRINT "        " + CHR$(34) + CHR$(34) + "  for random light to dark mono fade."
PRINT
INPUT "Enter Color Mix"; Mix$: Mix$ = UCASE$(Mix$)
IF Mix$ = "R" THEN Mix$ = RainBowMix$(Mix$)
IF LEN(Mix$) < PSize THEN Mix$ = MonoMix$
IF LEN(Mix$) > PSize THEN Mix$ = LEFT$(Mix$, PSize)
Mix$ = ConvertMix$(Mix$)
END SUB

'====================================================================
' Draw and rotate selected polygon
'====================================================================
SUB PolygonDraw (G)

DIM X(G) AS LONG, Y(G) AS LONG, Z(G) AS LONG, T(G) AS LONG, Count AS LONG
DIM SU AS SINGLE, RU AS SINGLE, Delay AS LONG, SX AS SINGLE

READ A$
CLS : LOCATE 2, 1: PRINT " Polygon: "; : COLOR 12: PRINT A$: PRINT : COLOR 10

INPUT " Rotational Spacing"; SX                  'Polygon parameters
IF SX = 0 THEN SX = 10: LOCATE CSRLIN - 1, 21: PRINT SX
SU = SX / 100: RU = 1 - SU
PRINT : INPUT " Polygon Count"; Count
IF Count = 0 THEN Count = 20 * G: : LOCATE CSRLIN - 1, 16: PRINT Count
PRINT : INPUT " Palette Cycle Speed"; Delay
IF Delay = 0 THEN IF G < 6 THEN Delay = 2000 ELSE Delay = 6000 / G : LOCATE CSRLIN - 1, 22: PRINT Delay
PRINT : INPUT " Left, Right or Pulse Cycle (L/R/P)"; S$: S$ = UCASE$(S$)
LOCATE CSRLIN - 1, 38
SELECT CASE S$
  CASE "R": L = 0: PRINT "Right"
  CASE "L": L = 1: PRINT "Left"
  CASE "P": L = 2: PRINT "Pulse"
  CASE ELSE:   L = 1: PRINT "Left"
END SELECT
PSize = G
FOR N = 1 TO PSize                               'Fill coord arrays
  READ X(N): READ Y(N): Y(N) = 479 - Y(N)
NEXT
PalSet
FOR N = 1 TO Count                               'Loop thru C rotations
  PSET (X(1), Y(1))
  FOR M = 1 TO G                                 'Loop thru G sides
    NJ = M + 1
    IF NJ = G + 1 THEN NJ = 1
    LINE -(X(NJ), Y(NJ)), C(M)
    Z(M) = RU * X(M) + SU * X(NJ)                'Downsize coords for next loop
    T(M) = RU * Y(M) + SU * Y(NJ)
  NEXT
  FOR P = 1 TO G                                 'Fill arrays with downsized coords
    X(P) = Z(P): Y(P) = T(P)
  NEXT
NEXT
Rotate Delay, L
PALETTE
END SUB

'====================================================================
' Fill Mix$ with random colors
'====================================================================
FUNCTION RainBowMix$ (Mix$)

RANDOMIZE TIMER
Mix$ = ""
FOR N = 1 TO PSize
  A = RND * 15 + 1
  IF A < 10 THEN Mix$ = Mix$ + RIGHT$(STR$(A), 1)
  IF A > 9 THEN Mix$ = Mix$ + CHR$(A + 55)
NEXT
RainBowMix$ = Mix$

END FUNCTION

'====================================================================
'Rotate palette
'====================================================================
SUB Rotate (Delay AS LONG, Turn AS INTEGER)

DIM P1 AS LONG, P2 AS LONG
X = Turn
Temp = PSize
DO
  P1 = PMix(1)                                   'Save the 1st attribute value
  FOR N = 2 TO PSize                             'Move the rest up by 1
    P2 = PMix(N)
    PMix(N - 1) = P2
  NEXT N
  PMix(PSize) = P1                               'Set last attribute to 1st attribute value
  FOR N = PSize TO 1 STEP -1                     'Rotate Palette
    FOR P1 = 1 TO Delay: NEXT                    'Delay
    P = N                                        'Left cycle
    IF Turn = 1 THEN P = PSize + 1 - N           'Right cycle
    PALETTE P, PMix(N)                           'Set palette color value
  NEXT
  IF X = 2 THEN                                  'Pulse cycle
    Temp = Temp - 1
    IF Temp = 0 THEN
      Temp = PSize
      IF Turn = 1 THEN Turn = 0 ELSE Turn = 1
    END IF
  END IF
LOOP WHILE INKEY$ = ""
END SUB

